﻿/*
 * Created by SharpDevelop.
 * User: Andreas
 * Date: 22.08.2018
 * Time: 21:44
 * 
 * To change this template use Tools | Options | Coding | Edit Standard Headers.
 */

using CevoAILib;

namespace AI
{

    /// <summary>
    /// Description of SettlerFunctions.
    /// </summary>
    sealed class SettlerFunctions
	{
		public SettlerFunctions()
		{
		}

        public int numberOfFoodLand(Location unitLoc)
        {
            int numFoodLand = 0;
            Location checkLand = new Location();

            checkLand = unitLoc + new RC(-2, 1);
            if ((checkLand.Terrain == Terrain.Grassland)
                || (checkLand.Terrain == Terrain.Plains))
            {
                numFoodLand += 1;
            }

            checkLand = unitLoc + new RC(-2, 0);
            if ((checkLand.Terrain == Terrain.Grassland)
                || (checkLand.Terrain == Terrain.Plains))
            {
                numFoodLand += 1;
            }

            checkLand = unitLoc + new RC(-2, -1);
            if ((checkLand.Terrain == Terrain.Grassland)
                || (checkLand.Terrain == Terrain.Plains))
            {
                numFoodLand += 1;
            }

            checkLand = unitLoc + new RC(-1, 2);
            if ((checkLand.Terrain == Terrain.Grassland)
                || (checkLand.Terrain == Terrain.Plains))
            {
                numFoodLand += 1;
            }

            checkLand = unitLoc + new RC(-1, 1);
            if ((checkLand.Terrain == Terrain.Grassland)
                || (checkLand.Terrain == Terrain.Plains))
            {
                numFoodLand += 1;
            }

            checkLand = unitLoc + new RC(-1, 0);
            if ((checkLand.Terrain == Terrain.Grassland)
                || (checkLand.Terrain == Terrain.Plains))
            {
                numFoodLand += 1;
            }

            checkLand = unitLoc + new RC(-1, -1);
            if ((checkLand.Terrain == Terrain.Grassland)
                || (checkLand.Terrain == Terrain.Plains))
            {
                numFoodLand += 1;
            }

            checkLand = unitLoc + new RC(-1, -2);
            if ((checkLand.Terrain == Terrain.Grassland)
                || (checkLand.Terrain == Terrain.Plains))
            {
                numFoodLand += 1;
            }

            checkLand = unitLoc + new RC(0, 2);
            if ((checkLand.Terrain == Terrain.Grassland)
                || (checkLand.Terrain == Terrain.Plains))
            {
                numFoodLand += 1;
            }

            checkLand = unitLoc + new RC(0, 1);
            if ((checkLand.Terrain == Terrain.Grassland)
                || (checkLand.Terrain == Terrain.Plains))
            {
                numFoodLand += 1;
            }

            checkLand = unitLoc + new RC(0, -1);
            if ((checkLand.Terrain == Terrain.Grassland)
                || (checkLand.Terrain == Terrain.Plains))
            {
                numFoodLand += 1;
            }

            checkLand = unitLoc + new RC(0, -2);
            if ((checkLand.Terrain == Terrain.Grassland)
                || (checkLand.Terrain == Terrain.Plains))
            {
                numFoodLand += 1;
            }

            checkLand = unitLoc + new RC(1, 2);
            if ((checkLand.Terrain == Terrain.Grassland)
                || (checkLand.Terrain == Terrain.Plains))
            {
                numFoodLand += 1;
            }

            checkLand = unitLoc + new RC(1, 1);
            if ((checkLand.Terrain == Terrain.Grassland)
                || (checkLand.Terrain == Terrain.Plains))
            {
                numFoodLand += 1;
            }

            checkLand = unitLoc + new RC(1, 0);
            if ((checkLand.Terrain == Terrain.Grassland)
                || (checkLand.Terrain == Terrain.Plains))
            {
                numFoodLand += 1;
            }

            checkLand = unitLoc + new RC(1, -1);
            if ((checkLand.Terrain == Terrain.Grassland)
                || (checkLand.Terrain == Terrain.Plains))
            {
                numFoodLand += 1;
            }

            checkLand = unitLoc + new RC(1, -2);
            if ((checkLand.Terrain == Terrain.Grassland)
                || (checkLand.Terrain == Terrain.Plains))
            {
                numFoodLand += 1;
            }

            checkLand = unitLoc + new RC(2, 1);
            if ((checkLand.Terrain == Terrain.Grassland)
                || (checkLand.Terrain == Terrain.Plains))
            {
                numFoodLand += 1;
            }

            checkLand = unitLoc + new RC(2, 0);
            if ((checkLand.Terrain == Terrain.Grassland)
                || (checkLand.Terrain == Terrain.Plains))
            {
                numFoodLand += 1;
            }

            checkLand = unitLoc + new RC(2, -1);
            if ((checkLand.Terrain == Terrain.Grassland)
                || (checkLand.Terrain == Terrain.Plains))
            {
                numFoodLand += 1;
            }

            return numFoodLand;
        }

        bool lookForRoad(Location loc)
        {
            if ((loc.Improvement == TerrainImprovement.Irrigation) &&
                !(loc.HasRoad) && (!(loc.HasRiver)))
                return true;
            else return false;
        }

        public RelativeCoordinates seekForRoadLocation(Location cityLoc)
        {
            RelativeCoordinates RelCoor = new RelativeCoordinates(0, 0);

            if (lookForRoad(cityLoc + new RC(2, -1)))
            {
                RelCoor.a = 2;
                RelCoor.b = -1;
                return RelCoor;
            }
            else if (lookForRoad(cityLoc + new RC(2, 0)))
            {
                RelCoor.a = 2;
                RelCoor.b = 0;
                return RelCoor;
            }
            else if (lookForRoad(cityLoc + new RC(2, 1)))
            {
                RelCoor.a = 2;
                RelCoor.b = 1;
                return RelCoor;
            }
            else if (lookForRoad(cityLoc + new RC(1, 2)))
            {
                RelCoor.a = 1;
                RelCoor.b = 2;
                return RelCoor;
            }
            else if (lookForRoad(cityLoc + new RC(1, 1)))
            {
                RelCoor.a = 1;
                RelCoor.b = 1;
                return RelCoor;
            }
            else if (lookForRoad(cityLoc + new RC(1, 0)))
            {
                RelCoor.a = 1;
                RelCoor.b = 0;
                return RelCoor;
            }
            else if (lookForRoad(cityLoc + new RC(1, -1)))
            {
                RelCoor.a = 1;
                RelCoor.b = -1;
                return RelCoor;
            }
            else if (lookForRoad(cityLoc + new RC(1, -2)))
            {
                RelCoor.a = 1;
                RelCoor.b = -2;
                return RelCoor;
            }
            else if (lookForRoad(cityLoc + new RC(0, -2)))
            {
                RelCoor.a = 0;
                RelCoor.b = -2;
                return RelCoor;
            }
            else if (lookForRoad(cityLoc + new RC(0, -1)))
            {
                RelCoor.a = 0;
                RelCoor.b = -1;
                return RelCoor;
            }
            else if (lookForRoad(cityLoc + new RC(0, 1)))
            {
                RelCoor.a = 0;
                RelCoor.b = 1;
                return RelCoor;
            }
            else if (lookForRoad(cityLoc + new RC(0, 2)))
            {
                RelCoor.a = 0;
                RelCoor.b = 2;
                return RelCoor;
            }
            else if (lookForRoad(cityLoc + new RC(-1, 2)))
            {
                RelCoor.a = -1;
                RelCoor.b = 2;
                return RelCoor;
            }
            else if (lookForRoad(cityLoc + new RC(-1, 1)))
            {
                RelCoor.a = -1;
                RelCoor.b = 1;
                return RelCoor;
            }
            else if (lookForRoad(cityLoc + new RC(-1, 0)))
            {
                RelCoor.a = -1;
                RelCoor.b = 0;
                return RelCoor;
            }
            else if (lookForRoad(cityLoc + new RC(-1, -1)))
            {
                RelCoor.a = -1;
                RelCoor.b = -1;
                return RelCoor;
            }
            else if (lookForRoad(cityLoc + new RC(-1, -2)))
            {
                RelCoor.a = -1;
                RelCoor.b = -2;
                return RelCoor;
            }
            else if (lookForRoad(cityLoc + new RC(-2, -1)))
            {
                RelCoor.a = -2;
                RelCoor.b = -1;
                return RelCoor;
            }
            else if (lookForRoad(cityLoc + new RC(-2, 0)))
            {
                RelCoor.a = -2;
                RelCoor.b = 0;
                return RelCoor;
            }
            else if (lookForRoad(cityLoc + new RC(-2, 1)))
            {
                RelCoor.a = -2;
                RelCoor.b = 1;
                return RelCoor;
            }
            else
            {
                return RelCoor;
            }

        }

        bool lookForIrrigation(Location loc)
        {
            if ((loc.Terrain == Terrain.Prairie) ||
            (loc.Terrain == Terrain.Plains) ||
            (loc.Terrain == Terrain.Grassland))
            {
                if (!(loc.Improvement == TerrainImprovement.Irrigation)) return true;
                else return false;
            }
            else return false;
        }

        public RelativeCoordinates seekForIrrigationLocation(Location cityLoc)
        {
            RelativeCoordinates RelCoor = new RelativeCoordinates(0, 0);

            if (lookForIrrigation(cityLoc + new RC(-2, 1)))
            {
                RelCoor.a = -2;
                RelCoor.b = 1;
                return RelCoor;
            }
            else if (lookForIrrigation(cityLoc + new RC(-2, 0)))
            {
                RelCoor.a = -2;
                RelCoor.b = 0;
                return RelCoor;
            }
            else if (lookForIrrigation(cityLoc + new RC(-2, -1)))
            {
                RelCoor.a = -2;
                RelCoor.b = -1;
                return RelCoor;
            }
            else if (lookForIrrigation(cityLoc + new RC(-1, -2)))
            {
                RelCoor.a = -1;
                RelCoor.b = -2;
                return RelCoor;
            }
            else if (lookForIrrigation(cityLoc + new RC(-1, -1)))
            {
                RelCoor.a = -1;
                RelCoor.b = -1;
                return RelCoor;
            }
            else if (lookForIrrigation(cityLoc + new RC(-1, 0)))
            {
                RelCoor.a = -1;
                RelCoor.b = 0;
                return RelCoor;
            }
            else if (lookForIrrigation(cityLoc + new RC(-1, 1)))
            {
                RelCoor.a = -1;
                RelCoor.b = 1;
                return RelCoor;
            }
            else if (lookForIrrigation(cityLoc + new RC(-1, 2)))
            {
                RelCoor.a = -1;
                RelCoor.b = 2;
                return RelCoor;
            }
            else if (lookForIrrigation(cityLoc + new RC(0, 2)))
            {
                RelCoor.a = 0;
                RelCoor.b = 2;
                return RelCoor;
            }
            else if (lookForIrrigation(cityLoc + new RC(0, 1)))
            {
                RelCoor.a = 0;
                RelCoor.b = 1;
                return RelCoor;
            }
            else if (lookForIrrigation(cityLoc + new RC(0, -1)))
            {
                RelCoor.a = 0;
                RelCoor.b = -1;
                return RelCoor;
            }
            else if (lookForIrrigation(cityLoc + new RC(0, -2)))
            {
                RelCoor.a = 0;
                RelCoor.b = -2;
                return RelCoor;
            }
            else if (lookForIrrigation(cityLoc + new RC(1, -2)))
            {
                RelCoor.a = 1;
                RelCoor.b = -2;
                return RelCoor;
            }
            else if (lookForIrrigation(cityLoc + new RC(1, -1)))
            {
                RelCoor.a = 1;
                RelCoor.b = -1;
                return RelCoor;
            }
            else if (lookForIrrigation(cityLoc + new RC(1, 0)))
            {
                RelCoor.a = 1;
                RelCoor.b = 0;
                return RelCoor;
            }
            else if (lookForIrrigation(cityLoc + new RC(1, 1)))
            {
                RelCoor.a = 1;
                RelCoor.b = 1;
                return RelCoor;
            }
            else if (lookForIrrigation(cityLoc + new RC(1, 2)))
            {
                RelCoor.a = 1;
                RelCoor.b = 2;
                return RelCoor;
            }
            else if (lookForIrrigation(cityLoc + new RC(2, 1)))
            {
                RelCoor.a = 2;
                RelCoor.b = 1;
                return RelCoor;
            }
            else if (lookForIrrigation(cityLoc + new RC(2, 0)))
            {
                RelCoor.a = 2;
                RelCoor.b = 0;
                return RelCoor;
            }
            else if (lookForIrrigation(cityLoc + new RC(2, -1)))
            {
                RelCoor.a = 2;
                RelCoor.b = -1;
                return RelCoor;
            }
            else
            {
                return RelCoor;
            }
        }

        public MapDirection changeDirection(MapDirection MainSearchDir)
        {
            if (MainSearchDir == MapDirection.North) MainSearchDir = MapDirection.NorthEast;
            else if (MainSearchDir == MapDirection.NorthEast) MainSearchDir = MapDirection.East;
            else if (MainSearchDir == MapDirection.East) MainSearchDir = MapDirection.SouthEast;
            else if (MainSearchDir == MapDirection.SouthEast) MainSearchDir = MapDirection.South;
            else if (MainSearchDir == MapDirection.South) MainSearchDir = MapDirection.SouthWest;
            else if (MainSearchDir == MapDirection.SouthWest) MainSearchDir = MapDirection.West;
            else if (MainSearchDir == MapDirection.West) MainSearchDir = MapDirection.NorthWest;
            else if (MainSearchDir == MapDirection.NorthWest) MainSearchDir = MapDirection.North;

            return MainSearchDir;
        }

        public RelativeCoordinates translateCompassToRC(MapDirection Compass)
        {
            RelativeCoordinates RelativeCoor = new RelativeCoordinates(0, 0);

            if (Compass == MapDirection.North)
            {
                RelativeCoor.a = -1;
                RelativeCoor.b = -1;
            }
            else if (Compass == MapDirection.NorthEast)
            {
                RelativeCoor.a = 0;
                RelativeCoor.b = -1;
            }
            else if (Compass == MapDirection.East)
            {
                RelativeCoor.a = 1;
                RelativeCoor.b = -1;
            }
            else if (Compass == MapDirection.SouthEast)
            {
                RelativeCoor.a = 1;
                RelativeCoor.b = 0;
            }
            else if (Compass == MapDirection.South)
            {
                RelativeCoor.a = 1;
                RelativeCoor.b = 1;
            }
            else if (Compass == MapDirection.SouthWest)
            {
                RelativeCoor.a = 0;
                RelativeCoor.b = 1;
            }
            else if (Compass == MapDirection.West)
            {
                RelativeCoor.a = -1;
                RelativeCoor.b = 1;
            }
            else if (Compass == MapDirection.NorthWest)
            {
                RelativeCoor.a = -1;
                RelativeCoor.b = 0;
            }
            return RelativeCoor;
        }

        public MapDirection translateRCtoCompass(RelativeCoordinates RelCoor)
        {
            MapDirection Compass = new MapDirection();

            if ((RelCoor.a == -1) && (RelCoor.b == -1)) Compass = MapDirection.North;
            else if ((RelCoor.a == 0) && (RelCoor.b == -1)) Compass = MapDirection.NorthEast;
            else if ((RelCoor.a == 1) && (RelCoor.b == -1)) Compass = MapDirection.East;
            else if ((RelCoor.a == 1) && (RelCoor.b == 0)) Compass = MapDirection.SouthEast;
            else if ((RelCoor.a == 1) && (RelCoor.b == 1)) Compass = MapDirection.South;
            else if ((RelCoor.a == 0) && (RelCoor.b == 1)) Compass = MapDirection.SouthWest;
            else if ((RelCoor.a == -1) && (RelCoor.b == 1)) Compass = MapDirection.West;
            else if ((RelCoor.a == -1) && (RelCoor.b == 0)) Compass = MapDirection.NorthWest;

            return Compass;
        }


        public RelativeCoordinates calculateRelCoors(RC RelCoor)
        {
            RelativeCoordinates RelativeCoor = new RelativeCoordinates(0, 0);

            if (RelCoor.a == RelCoor.b)
            {
                if (RelCoor.a > 0)
                {
                    RelativeCoor.a = 1;
                    RelativeCoor.b = 1;
                }
                else if (RelCoor.a < 0)
                {
                    RelativeCoor.a = -1;
                    RelativeCoor.b = -1;
                }
            }
            else if (RelCoor.a == -RelCoor.b)
            {
                if (RelCoor.a > 0)
                {
                    RelativeCoor.a = 1;
                    RelativeCoor.b = -1;
                }
                else if (RelCoor.a < 0)
                {
                    RelativeCoor.a = -1;
                    RelativeCoor.b = 1;
                }
            }
            else if ((RelCoor.a > 0) && (RelCoor.b > 0))
            {
                if (RelCoor.a > RelCoor.b) RelativeCoor.a = 1;
                else RelativeCoor.b = 1;
            }
            else if ((RelCoor.a < 0) && (RelCoor.b < 0))
            {
                if (RelCoor.a > RelCoor.b) RelativeCoor.b = -1;
                else RelativeCoor.a = -1;
            }
            else if ((RelCoor.a > 0) && (RelCoor.b < 0))
            {
                if (RelCoor.a > -RelCoor.b) RelativeCoor.a = 1;
                else RelativeCoor.b = -1;
            }
            else if ((RelCoor.a < 0) && (RelCoor.b > 0))
            {
                if (RelCoor.b > -RelCoor.a) RelativeCoor.b = 1;
                else RelativeCoor.a = -1;
            }
            else if (RelCoor.a == 0)
            {
                if (RelCoor.b > 0) RelativeCoor.b = 1;
                else RelativeCoor.b = -1;
            }
            else if (RelCoor.b == 0)
            {
                if (RelCoor.a > 0) RelativeCoor.a = 1;
                else RelativeCoor.a = -1;
            }
            return RelativeCoor;
        }
    }
}


