﻿/*
 * Created by SharpDevelop.
 * User: Andreas
 * Date: 14.01.2018
 * Time: 16:39
 * 
 * To change this template use Tools | Options | Coding | Edit Standard Headers.
 */
using System;
using CevoAILib;

namespace AI
{	
	/// <summary>
	/// Basic City class
	/// </summary>
	sealed class XCity
	{
		public static int numOfCities = 0;
		public int cID;
		public int assignedSettlerID;
		public int assignedSettlerNum;
		public bool cityNeedsImprovements;
		public bool cityHasSettler;
		public Location cityLocation;
		
		public XCity(int ID, Location Loc)
		{
			cID = ID;
			cityLocation = Loc;
			assignedSettlerID = -1;
			assignedSettlerNum = -1;
			cityNeedsImprovements = true;
			cityHasSettler = false;
		}
		
		public void increaseNumOfCities()
		{
			numOfCities += 1;
		}
		
		public int readNumOfCities()
		{
			return numOfCities;
		}
	}
	
	
	/// <summary>
	/// Administrate City Struct
	/// </summary>
	public class CityAdmin
	{
		public int numCities = 1;
		public CityAdmin()
		{
		}
	}
}
